/**
 * @version 2.0  17-07-2019
 * @author Matas Contreras, Camilo Fernndez, Mara Rivas
 */

import java.math.*;
import javax.swing.*;
import java.nio.file.*;
import java.awt.event.*;

public class ButtonCalculate implements ActionListener{
	public ButtonCalculate(JLabel name, JTextField dataPA, 
			JTextField dataRAP, JTextField dataAA, JTextField dataIA){
		user = name;
		PA = dataPA;
		RAP = dataRAP;
		AA = dataAA;
		IA = dataIA;
		
		FAE = first = second = fourth = fifth = 0.0;
		sem = average = sigmaOne = sigmaTwo = third = 0;
		totalCredits = approvesCredits = assignedCredits = 0;
	}
	
	public void actionPerformed(ActionEvent actionCalculate){
		if(user.getText() == "Nombre")
			JOptionPane.showMessageDialog(new JFrame(),	
					"Debe ingresar un usuario antes de calcular sus indicadores acadmicos. ", "Error", JOptionPane.ERROR_MESSAGE);
		else{
			userFile = Paths.get("users\\" + user.getText() + ".txt");
			try{
				/* Section for read data */
				dataByte = Files.readAllBytes(userFile);
				data = new String(dataByte);					// all files
				singleData = data.split("\n");					// n lines separate by "\n"
				
				for(i = 1; i<singleData.length; i++){
					if(singleData[i].split("\t").length == 6){		// Lines with FAE
						lineData = singleData[i].split("\t");
						
						/* Section to get data */
						sem = Integer.parseInt(lineData[0]);
						assignedCredits = Integer.parseInt(lineData[4]);
						auxiliar = lineData[5].split("\r");
						average = Integer.parseInt(auxiliar[0]);
						sigmaOne += average*assignedCredits;
						sigmaTwo += assignedCredits;
						totalCredits += Integer.parseInt(lineData[4]);
						if(average >= 55){ approvesCredits += Integer.parseInt(lineData[4]); }
						
						
					}else if(singleData[i].split("\t").length == 7){		// Lines without FAE
						lineDataFAE = singleData[i].split("\t");
						
						/* Section to get data */
						sem = Integer.parseInt(lineDataFAE[0]);
						assignedCredits = Integer.parseInt(lineDataFAE[4]);
						average = Integer.parseInt(lineDataFAE[5]);
						sigmaOne += average*assignedCredits;
						sigmaTwo += assignedCredits;
						totalCredits += Integer.parseInt(lineDataFAE[4]);
						if(average >= 55){ approvesCredits += Integer.parseInt(lineDataFAE[4]); }
						FAE = Double.parseDouble(lineDataFAE[6]);
					}
				}
				
				/* Section to calculate indicators */
				first = (double)sigmaOne /(CONSTANT*(Math.pow((double)sem, POW)));
				second = first*((double)approvesCredits /(double)totalCredits)*FAE*FACTOR;
				auxRoundPA = new BigDecimal(second);
				roundPA = auxRoundPA.setScale(3, RoundingMode.DOWN);
				second = roundPA.doubleValue();
				PA.setText(Double.toString(second));
				
				third = sigmaOne/sigmaTwo;
				RAP.setText(Integer.toString(third));
				
				fourth = (double)approvesCredits /(double)sem;
				auxRoundAA = new BigDecimal(fourth);
				roundAA = auxRoundAA.setScale(3, RoundingMode.DOWN);
				fourth = roundAA.doubleValue();
				AA.setText(Double.toString(fourth));
				
				fifth = ((double)third*(double)approvesCredits) /(double)totalCredits;
				auxRoundIA = new BigDecimal(fifth);
				roundIA = auxRoundIA.setScale(3, RoundingMode.DOWN);
				fifth = roundIA.doubleValue();
				IA.setText(Double.toString(fifth));
				
				/* Reset values */
				FAE = first = second = fourth = fifth = 0.0;
				sem = average = sigmaOne = sigmaTwo = third = 0;
				totalCredits = approvesCredits = assignedCredits = 0;

			}catch(Exception exp){
				PA.setText("");
				RAP.setText("");
				AA.setText("");
				IA.setText("");
				
				JOptionPane.showMessageDialog(new JFrame(),	
						"No se puede leer el archivo de usuario. Intente nuevamente. ", "Error", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
	private double FAE, first, second, fourth, fifth;
	private int i, sem, average, sigmaOne, sigmaTwo, third;
	private int totalCredits, approvesCredits, assignedCredits;
	private BigDecimal roundPA, auxRoundPA, roundAA, auxRoundAA, roundIA, auxRoundIA;
	
	private String data;
	private byte[] dataByte;
	private String[] singleData, lineData, lineDataFAE, auxiliar;
	
	public JLabel user;
	private Path userFile;
	public JTextField PA, RAP, AA, IA;
	
	public static final double POW = 1.06;
	public static final double FACTOR = 100.0;
	public static final double CONSTANT = 14.0;
}
