/**
 * @version 2.0  17-07-2019
 * @author Matas Contreras, Camilo Fernndez, Mara Rivas
 */

import javax.swing.*;
import java.nio.file.*;
import java.awt.event.*;

public class ButtonEnterFAE implements ActionListener{
	public ButtonEnterFAE(JTextField dataFAE, JLabel name, JTextField sem,
			JTextField anno, JTextField subject, JTextField init, JTextField cred, JTextField aver, JTextArea textArea){
		FAE = dataFAE;
		user = name;
		semester = sem;
		year = anno;
		matter = subject;
		initials = init;
		credits = cred;
		average = aver;
		state = textArea;
	}
	
	public void actionPerformed(ActionEvent actionEnter){
		if(user.getText() == "Nombre")
			JOptionPane.showMessageDialog(new JFrame(),	
					"Debe ingresar un usuario antes de ingresar su FAE. ", "Error", JOptionPane.ERROR_MESSAGE);
		else{
			userFile = Paths.get("users\\" + user.getText() + ".txt");
			try{
				/* Section for format error */
				Double.parseDouble(FAE.getText());
				
				/* Section for append FAE */
				dataByte = Files.readAllBytes(userFile);
				data = new String(dataByte);								// all files
				singleData = data.split("\n");								// n lines separate by "\n"
				lineData = singleData[singleData.length-1].split("\t");		// n-1 line
				newLineData = new String[lineData.length+1];				// n+1 data
				
				for(i = 0; i<newLineData.length; i++){
					if(i == (newLineData.length - 2)){ 
						newSingleData = lineData[i].split("\r");
						newLineData[i] = newSingleData[0]; }
					
					else if(i == (newLineData.length - 1)){ newLineData[i] = FAE.getText(); }
					else{ newLineData[i] = lineData[i]; }
				}
				
				newNewLineData = convertArrayToString(newLineData);
				singleData[singleData.length-1] = newNewLineData;
				
				for(j = 0; j<singleData.length; j++){
					if(j == 0){ newData = singleData[j] + "\r\n"; }
					else if(j == (singleData.length - 1)){ newData += singleData[j]; }
					else{ newData += singleData[j] + "\r\n"; }
				}
				
				/* Create new data */
				Files.deleteIfExists(userFile);
				Files.write(userFile, newData.getBytes());
				dataByte = null;
				
				/* Section JTextArea (write data in window) */
				dataByte = Files.readAllBytes(userFile);
				parsecData = new String(dataByte);
				lineData = parsecData.split("\n");
				
				for(j = 0; j<lineData.length; j++){
					stateData = lineData[j].split("\t");
					
					for(i = 0; i<stateData.length; i++){
						if((i == 0) && (j == 0)){ windowData = stateData[i] + "\t"; }
						else if(i == 2){ 
							if(matter.getText().length() < 15) windowData += stateData[i] + "\t\t\t";
							else if(matter.getText().length() < 30) windowData += stateData[i] + "\t\t"; }
						
						else if(i == (stateData.length - 1)){ windowData += stateData[i] + "\r\n"; }
						else{ windowData += stateData[i] + "\t"; }
					}
				}
				
				state.setText(windowData);
				windowData = null;
				
				/* Clean JLabels of window */
				FAE.setText("");
				FAE.setEditable(false);
				
				/* Don't enter new subjects data */
				semester.setEnabled(true);
				year.setEnabled(true);
				matter.setEnabled(true);
				initials.setEnabled(true);
				credits.setEnabled(true);
				average.setEnabled(true);
				
			}catch(NumberFormatException exp){		// Format error: FAE
				FAE.setText("");
				JOptionPane.showMessageDialog(new JFrame(),	
						"Debe ingresar un nmero decimal vlido (utilice punto). ", "FAE", JOptionPane.ERROR_MESSAGE);

			}catch(Exception exp){		// For any other error
				FAE.setText("");
				JOptionPane.showMessageDialog(new JFrame(),	
						"No se puede ingresar la asignatura. Intente nuevamente. ", "Error", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
    public static String convertArrayToString(String[] array){
    	int k;
        StringBuilder builder = new StringBuilder();
        
        for(k = 0; k<array.length; k++){
            if(k == (array.length - 1)){ 
            	builder.append(array[k]);
            	builder.append("\r\n");
            }else{ 
            	builder.append(array[k]);
                builder.append("\t"); }}
         
        return builder.toString();
    }
	
    private int i, j;
	private Path userFile;
	private byte[] dataByte;
	private String data, newData, parsecData, windowData, newNewLineData;
	private String[] singleData, lineData, newSingleData, newLineData, stateData;
	
	public JLabel user;
	public JTextArea state;
	public JTextField semester, year, matter, initials, credits, average, FAE;
}
