/**
 * @version 2.0  18-07-2019
 * @author Matas Contreras, Camilo Fernndez, Mara Rivas
 */

import javax.swing.*;
import java.nio.file.*;
import java.awt.event.*;

public class ButtonEnterMatter implements ActionListener{
	public ButtonEnterMatter(JTextField sem, JTextField anno, JTextField subject, 
			JTextField init, JTextField cred, JTextField aver, JLabel name, JTextArea area, JTextField dataFAE){
		helpYear = 0;
		helpSem = 1;
		FAE = dataFAE;
		semester = sem;
		year = anno;
		matter = subject;
		initials = init;
		credits = cred;
		average = aver;
		user = name;
		textArea = area;
		one = two = three = four = false;
	}
	
	public void actionPerformed(ActionEvent actionEnter){
		if(user.getText() == "Nombre")
			JOptionPane.showMessageDialog(new JFrame(),	
					"Debe ingresar un usuario antes de ingresar asignaturas. ", "Error", JOptionPane.ERROR_MESSAGE);
		else{
			userFile = Paths.get("users\\" + user.getText() + ".txt");
			try{
				/* Section for format error */
				one = true;
				Integer.parseInt(semester.getText());
				two = true;
				Integer.parseInt(year.getText());
				
				if(matter.getText().length() >= 30){
					matter.setText(null);
					JOptionPane.showMessageDialog(new JFrame(),	
							"Ingrese un nombre con un mximo de 29 carcteres. ", "Asignatura", JOptionPane.WARNING_MESSAGE);
				}else{
					three = true;		
					Integer.parseInt(credits.getText());
					four = true;		
					Integer.parseInt(average.getText());
					
					/* Section for append data to file */
					data = semester.getText() + "\t" + year.getText() + "\t" + matter.getText() +  
							"\t" + initials.getText() + "\t" + credits.getText() + "\t" + average.getText() + "\r\n";
					Files.write(userFile, data.getBytes(), StandardOpenOption.APPEND);
					
					/* Section JTextArea (write data in window) */
					dataByte = Files.readAllBytes(userFile);
					parsecData = new String(dataByte);
					newLineData = parsecData.split("\n");
					
					for(j = 0; j<newLineData.length; j++){
						singleData = newLineData[j].split("\t");
						
						for(i = 0; i<singleData.length; i++){
							if((i == 0) && (j == 0)){ windowData = singleData[i] + "\t"; }
							else if(i == 2){
								if(j == 0) 
									windowData += singleData[i] + "\t\t\t";
								else if((singleData[2].length() < 15) && (j != 0)) 
									windowData += singleData[i] + "\t\t\t";
								else if((singleData[2].length()) < 30 && (j != 0))
									windowData += singleData[i] + "\t\t";
							}
							else if(i == (singleData.length - 1)){ windowData += singleData[i] + "\r\n"; }
							else{ windowData += singleData[i] + "\t"; }
						}
					}
					
					textArea.setText(windowData);
					windowData = null;
					
					/* Section FAE */
					resultYear = Integer.parseInt(year.getText()) - helpYear;
					resultSem = Integer.parseInt(semester.getText()) - helpSem;
					
					if((newLineData.length == 2) ^ (resultSem == 1) ^ (resultYear == 1)){
						FAE.setEditable(true);
						helpYear = Integer.parseInt(year.getText());
						helpSem = Integer.parseInt(semester.getText());
						
						/* Window to notify of FAE */
						JOptionPane.showMessageDialog(new JFrame(),	
								"Debe ingresar su FAE antes de continuar. \r\n"
										+ "Si usted no conoce su FAE, ingrese ''1.00'' (valor por defecto). ", 
										"Importante", JOptionPane.INFORMATION_MESSAGE);
						
						/* Don't enter new subjects data */
						semester.setEnabled(false);
						year.setEnabled(false);
						matter.setEnabled(false);
						initials.setEnabled(false);
						credits.setEnabled(false);
						average.setEnabled(false);
					}
					
					/* Clean JLabels of window */
					semester.setText("");
					year.setText("");
					matter.setText("");
					initials.setText("");
					credits.setText("");
					average.setText("");
				}
				
			}catch(NumberFormatException exp){
				if(four){							// Format error: average
					average.setText("");
					JOptionPane.showMessageDialog(new JFrame(),	
							"Debe ingresar un nmero entero vlido. ", "Nota", JOptionPane.ERROR_MESSAGE);
				
				}else if(three){					// Format error: credits
					credits.setText("");
					JOptionPane.showMessageDialog(new JFrame(),	
							"Debe ingresar un nmero entero vlido. ", "Crditos", JOptionPane.ERROR_MESSAGE);
					
				}else if(two){						// Format error: year
					year.setText("");
					JOptionPane.showMessageDialog(new JFrame(),	
							"Debe ingresar un nmero entero vlido. ", "Ao", JOptionPane.ERROR_MESSAGE);
					
				}else if(one){						// Format error: semester
					semester.setText("");
					JOptionPane.showMessageDialog(new JFrame(),	
						"Debe ingresar un nmero entero vlido. ", "Semestre", JOptionPane.ERROR_MESSAGE);
				}
				
			}catch(Exception exp){			// For any other error
				semester.setText("");
				year.setText("");
				matter.setText("");
				initials.setText("");
				credits.setText("");
				average.setText("");
			
				JOptionPane.showMessageDialog(new JFrame(),	
						"No se puede ingresar la asignatura. Intente nuevamente. ", "Error", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
	private Path userFile;
	private byte[] dataByte;
	private boolean one, two, three, four;
	private String[] singleData, newLineData;
	private String data, parsecData, windowData;
	private int helpYear, helpSem, resultYear, resultSem, i, j;
	
	public JLabel user;
	public JTextArea textArea;
	public JTextField semester, year, matter, initials, credits, average, FAE;
}
