/**
 * @version 2.0  16-07-2019
 * @author Matas Contreras, Camilo Fernndez, Mara Rivas
 */

import java.awt.*;
import javax.swing.*;
import java.nio.file.*;
import java.awt.event.*;

public class ButtonRemove implements ActionListener{
	public ButtonRemove(JLabel user, JTextArea area, JTextField FAE){
		dataFAE = FAE;
		userName = user;
		textArea = area;
		window = new JFrame();
		window.setTitle("Borrar Usuario");
		window.setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		
		// Obtiene dimensiones de la pantalla
	    Toolkit myScreen = Toolkit.getDefaultToolkit();
		Dimension screenSize = myScreen.getScreenSize();
		int widthScreen = screenSize.width;
		int heigthScreen = screenSize.height;
		  
	    // Ventana inicia en el centro
		window.setLocation(widthScreen/2 - DEFAULT_WIDTH/2, heigthScreen/2 - DEFAULT_HEIGHT/2);
	    
		// Define el cono de la ventana
	    Image yakitoIcono = myScreen.getImage("images/yakito.png");
	    window.setIconImage(yakitoIcono);
	    
	    no = new JButton("NO");
	    yes = new JButton("S");
	    no.setBounds(DEFAULT_WIDTH/2, DEFAULT_HEIGHT/2 - 15, 60, 25);
	    yes.setBounds(DEFAULT_WIDTH/2 - 80, DEFAULT_HEIGHT/2 - 15, 60, 25);
	    
	    text = new JLabel();
	    text.setText("Confirma que desea eliminar el usuario seleccionado?");
	    text.setBounds(20, 20, 350, 15);
	    
	    window.add(no);
	    window.add(yes);
	    window.add(text);
	}
	
	public void actionPerformed(ActionEvent actionRemove){
		window.setLayout(null);
	    window.setVisible(true);
	    
	    ButtonNo actionNo = new ButtonNo();
	    ButtonYes actionYes = new ButtonYes(userName, textArea, dataFAE);
	    no.addActionListener(actionNo);
	    yes.addActionListener(actionYes);
	}
	
	public class ButtonYes implements ActionListener{
		public ButtonYes(JLabel name, JTextArea textArea, JTextField newFAE){
			label = name;
			state = textArea;
			newDataFAE = newFAE;
		}
		
		public void actionPerformed(ActionEvent actionYes){
			try{
				words = label.getText();
				userFile = Paths.get("users\\" + words + ".txt");
				if(Files.exists(userFile)){
					Files.deleteIfExists(userFile);
					state.setText(null);
					label.setText("Nombre");
					newDataFAE.setEditable(true);
					window.dispose();
					
				}else{
					JOptionPane.showMessageDialog(new JFrame(),	
							"Debe ingresar un nombre de usuario en primera instancia. ", "Warning", JOptionPane.WARNING_MESSAGE);
				}
				
			}catch(Exception exception){
				JOptionPane.showMessageDialog(new JFrame(),	
						"No se ha podido eliminar el archivo de usuario. Intente nuevamente. ", "Error", JOptionPane.ERROR_MESSAGE);
			}
		}
		
		public JLabel label;
		public JTextArea state;
		public JTextField newDataFAE;
	}
	
	public class ButtonNo implements ActionListener{
		public void actionPerformed(ActionEvent actionNo){
			dataFAE.setEditable(true);
			window.dispose();
		}		
	}
	
	public JFrame window;
	public JLabel userName;
	public JTextArea textArea;
	public JTextField dataFAE;
	
	private JLabel text;
	private String words;
	private Path userFile;
	private JButton yes, no;
	
	public static final int DEFAULT_WIDTH = 370;
	public static final int DEFAULT_HEIGHT = 130;
}