/**
 * @version 2.0  05-07-2019
 * @author Matas Contreras, Camilo Fernndez, Mara Rivas
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class Instruction{
	public Instruction(JMenuItem instruction){
		item = instruction;
		window = new JFrame();
		window.setTitle("Instructivo");
		window.setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		
		// Obtiene dimensiones de la pantalla
	    Toolkit myScreen = Toolkit.getDefaultToolkit();
		Dimension screenSize = myScreen.getScreenSize();
		int widthScreen = screenSize.width;
		int heigthScreen = screenSize.height;
		  
	    // Ventana inicia en el centro
		window.setLocation(widthScreen/2 - DEFAULT_WIDTH/2, heigthScreen/2 - DEFAULT_HEIGHT/2);
	    
		// Define el cono de la ventana
	    Image yakitoIcono = myScreen.getImage("images/yakito.png");
	    window.setIconImage(yakitoIcono);
	    
	    close = new JButton("Salir");
	    close.setBounds(DEFAULT_WIDTH/2 - 30, DEFAULT_HEIGHT - 90, 60, 30);
	    
	    textArea = new JTextArea();
		textArea.setText("Hola! Soy ''PrioriJava'', software desarrollado en Java para calcular ciertos \n"
				+ "ndices acadmicos de los alumnos de la UTFSM Casa Central. Para saber\n"
				+ "tu situacin personal, debes seguir los siguientes pasos:\n"
				+ "\n"
				+ "1. Ingresar un nuevo usuario presionando en ''Nuevo''. \n"
				+ "2. Ingresar asignaturas mediante los campos ''Semestre'', ''Asignatura'', \n"
				+ "    ''Ao'', ''Asignatura'', ''Sigla'', ''Crditos'' y ''Nota'' para cada una, todos estos \n"
				+ "    presentes en ''Inscripcin de Asignaturas''.\n"
				+ "3. Una vez ingresadas todas las asignaturas correspondientes al semestre \n"
				+ "    en cuestin, debe especificar su FAE (Factor Acadmico Extracurricular). \n"
				+ "    En caso de no saber su valor, ingrese un ''1.00''.\n"
				+ "4. Si ya ingres sus datos, puede cargarlos en el men ''Usuarios'', ''Cargar \n"
				+ "    Datos'' y buscar el archivo de extensin ''txt'' en la carpeta ''users'' (aqu se \n"
				+ "    encuentran todos los archivos de usuarios).\n"
				+ "5. Finalmente, si ingres todos los datos necesarios, presione ''Calcular'' \n"
				+ "    para obtener sus ndices acadmicos. Note que siempre puede presionar \n "
				+ "    ''Limpiar'' previo al nuevo clculo de ndices acadmicos o para eliminar \n"
				+ "    los valores obtenidos en cierto semestre.");
		
		textArea.setBounds(15, 20, 420, 320);
		textArea.setEditable(false);
		textArea.setBackground(new Color(0, 0, 0, 0));
		
		window.add(close);
		window.add(textArea);
		window.setLayout(null);
		
		ButtonItem actionItem = new ButtonItem();
		item.addActionListener(actionItem);
	}
	
	public class ButtonItem implements ActionListener{
		public void actionPerformed(ActionEvent actionNew){
			window.setVisible(true);
			
			close.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent event){
					window.dispose();
				}
			});
		}
	}
	
	private JFrame window;
	private JMenuItem item;
	private JTextArea textArea;
	private JButton close;
	
	public static final int DEFAULT_WIDTH = 480;
	public static final int DEFAULT_HEIGHT = 420;
}
