/**
 * @version 2.0  18-07-2019
 * @author Matas Contreras, Camilo Fernndez, Mara Rivas.
 */

import java.awt.*;
import javax.swing.*;

public class PrioriJava{
	public static void main(String[] args){
		JMenu charge = new JMenu("Usuarios");					// JMenu: Users
		JMenu helpMenu = new JMenu("Ayuda");					// JMenu: Help
		
		final JMenuBar menu = new JMenuBar();							// JMenuBar
		final JMenuItem exit = new JMenuItem("Salir");					// JMenuItem: Exit
		final JMenuItem users = new JMenuItem("Cargar Datos");			// JMenuItem: Charge Data
	    final JMenuItem instruction = new JMenuItem("Instructivo");						// JMenuItem: Instructive
	    final JMenuItem information = new JMenuItem("Acerca de ''PrioriJava''");		// JMenuItem: About "PrioriJava"
		
	    menu.add(charge);				// Add Users sub-menu to menu bar
	    charge.add(users);				// Add Charge Data item to Users sub-menu
	    charge.add(exit);				// Add Exit item to Users sub-menu
	 	menu.add(helpMenu); 			// Add Help sub-menu to menu bar
	 	helpMenu.add(instruction);		// Add Instructive item to Help sub-menu
	 	helpMenu.add(information);		// Add About item to Help sub-menu
	 	
		SwingUtilities.invokeLater(new Runnable(){		// Implementation for Window
	    	public void run(){
	    		Window frame = new Window(exit, users, instruction, information);
	    		frame.setJMenuBar(menu);
	    		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	            frame.setVisible(true);
	    	}
	    });
	}
}

class Window extends JFrame{
	/* Builder of the window with his elements, buttons, texts areas, etc. */
	public Window(JMenuItem exit, JMenuItem users, JMenuItem instruction, JMenuItem information){
		setTitle("''PrioriJava'': Clculo de Prioridad Acadmica y otros Indicadores");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		
		/* Obtiene dimensiones de la pantalla */
	    Toolkit myScreen = Toolkit.getDefaultToolkit();
		Dimension screenSize = myScreen.getScreenSize();
		int widthScreen = screenSize.width;
		int heigthScreen = screenSize.height;
		  
	    /* Ventana inicia en el centro */
		setLocation(widthScreen/2 - DEFAULT_WIDTH/2, heigthScreen/2 - DEFAULT_HEIGHT/2);
	    
		/* Define el cono de la ventana */
	    Image yakitoIcono = myScreen.getImage("images/yakito.png");
	    setIconImage(yakitoIcono);
	    
	    /* User file section */
	    subArea = new JLabel("Avance Acadmico Cronolgico"); 
	    subArea.setBounds(30, 260, 180, 20);
	    
	    textArea = new JTextArea();
	    textArea.setBounds(25, 285, 820, 220);
		textArea.setEditable(false);
		textArea.setBackground(Color.WHITE);
		
		scrollArea = new JScrollPane(textArea);
		scrollArea.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollArea.setBounds(25, 285, 770, 220);
		
		add(subArea);
		add(scrollArea);
	    
	    /* Subject registration section */
	    subjects = new JLabel("Inscripcin de Asignaturas");
	    semesterOne = new JLabel("Semestre:");
	    year = new JLabel("Ao:");
	    matter = new JLabel("Asignatura:");
	    initials = new JLabel("Sigla:");
	    credits = new JLabel("Crditos:");
	    average = new JLabel("Nota:");
	    
	    dataSem = new JTextField();
	    dataYear = new JTextField();
	    dataMatter = new JTextField();
	    dataInit = new JTextField();
	    dataCredits = new JTextField();
	    dataAver = new JTextField();
	    
	    enter = new JButton("Ingresar");
	    cleanSubject = new JButton("Limpiar");
	    
	    subjects.setBounds(160, 15, 155, 20);
	    subjects.setHorizontalAlignment(SwingConstants.CENTER);
	    semesterOne.setBounds(160, 55, 90, 20);
	    year.setBounds(415, 55, 40, 20);
	    matter.setBounds(160, 80, 70, 20);
	    initials.setBounds(160, 105, 100, 20);
	    credits.setBounds(340, 105, 100, 20);
	    average.setBounds(160, 130, 100, 20);
	    
	    dataSem.setBounds(235, 55, 30, 20);
	    dataYear.setBounds(450, 55, 40, 20);
	    dataMatter.setBounds(235, 80, 255, 20);
	    dataInit.setBounds(235, 105, 70, 20);
	    dataCredits.setBounds(400, 105, 25, 20);
	    dataAver.setBounds(235, 130, 40, 20);
	    
	    enter.setBounds(160, 170, 90, 25);
	    cleanSubject.setBounds(270, 170, 80, 25);
	    
	    add(subjects);
	    add(semesterOne);
	    add(year);
	    add(matter);
	    add(initials);
	    add(credits);
	    add(average);
	    
	    add(dataSem);
	    add(dataYear);
	    add(dataMatter);
	    add(dataInit);
	    add(dataCredits);
	    add(dataAver);
	    
	    add(enter);
	    add(cleanSubject);
	    
	    /* FAE entry section */
	    FAE = new JLabel("Factor Acadmico Extracurricular (FAE):");
	    dataFAE = new JTextField();
	    enterFAE = new JButton("Ingresar");
	    
	    FAE.setBounds(160, 220, 300, 20);
	    dataFAE.setBounds(400, 220, 40, 20);
	    enterFAE.setBounds(470, 215, 90, 25);
	    
	    add(FAE);
	    add(dataFAE);
	    add(enterFAE);
		
	    /* User data section */
	    name = new JLabel("Nombre");
	    user = new JLabel("Usuarios");
	    newUser = new JButton("Nuevo");
	    removeUser = new JButton("Eliminar");
	    
	    name.setBounds(25, 70, 100, 20);
	    name.setBackground(Color.WHITE);
	    name.setOpaque(true);
	    name.setHorizontalAlignment(SwingConstants.CENTER);
	    
	    user.setBounds(45, 15, 60, 20);
	    user.setHorizontalAlignment(SwingConstants.CENTER);
	    
	    newUser.setBounds(40, 145, 70, 25);
	    removeUser.setBounds(35, 180, 80, 25);
	    
	    add(name);
	    add(user);
	    add(newUser);
	    add(removeUser);
		
	    /* Action for users section */
	    ButtonNew actionNew = new ButtonNew(name, textArea, dataFAE);
	    newUser.addActionListener(actionNew);
	    
	    ButtonRemove actionRemove = new ButtonRemove(name, textArea, dataFAE);
	    removeUser.addActionListener(actionRemove);
	    
	    /* Action for matters section */
	    ButtonEnterMatter actionEnter = new ButtonEnterMatter(dataSem, 
	    		dataYear, dataMatter, dataInit, dataCredits, dataAver, name, textArea, dataFAE);
	    enter.addActionListener(actionEnter);
	    
	    ButtonCleanMatter actionCleanMatter = 
	    		new ButtonCleanMatter(dataSem, dataYear, dataMatter, dataInit, dataCredits, dataAver);
	    cleanSubject.addActionListener(actionCleanMatter);
	    
	    /* Action for FAE section */
	    ButtonEnterFAE actionFAE = new ButtonEnterFAE(dataFAE, name, 
	    		dataSem, dataYear, dataMatter, dataInit, dataCredits, dataAver, textArea);
	    enterFAE.addActionListener(actionFAE);
	    
	    /* Academic indicator section */
	    indicator = new JLabel("Indicadores Acadmicos");
	    PA = new JLabel("Prioridad Acadmica:");
	    RAP = new JLabel("Rendimiento Acadmico Ponderado:");
	    AA = new JLabel("Avance Acadmico:");
	    IA = new JLabel("ndice Acadmico:");
	    
	    dataPA = new JTextField();
	    dataRAP = new JTextField();
	    dataAA = new JTextField();
	    dataIA = new JTextField();
	    
	    calculate = new JButton("Calcular");
	    cleanIndic = new JButton("Limpiar");
	    
	    indicator.setBounds(525, 15, 155, 20);
	    PA.setBounds(525, 55, 150, 20);
	    RAP.setBounds(525, 80, 250, 20);
	    AA.setBounds(525, 105, 120, 20);
	    IA.setBounds(525, 130, 120, 20);
	    
	    dataPA.setBounds(750, 55, 70, 20);
	    dataPA.setEditable(false);
	    dataPA.setBackground(Color.WHITE);
	    dataRAP.setBounds(750, 80, 70, 20);
	    dataRAP.setEditable(false);
	    dataRAP.setBackground(Color.WHITE);
	    dataAA.setBounds(750, 105, 70, 20);
	    dataAA.setEditable(false);
	    dataAA.setBackground(Color.WHITE);
	    dataIA.setBounds(750, 130, 70, 20);
	    dataIA.setEditable(false);
	    dataIA.setBackground(Color.WHITE);
	    
	    calculate.setBounds(570, 170, 90, 25);
	    cleanIndic.setBounds(680, 170, 80, 25);
	    
	    add(indicator);
	    add(PA);
	    add(RAP);
	    add(AA);
	    add(IA);
	    
	    add(dataPA);
	    add(dataRAP);
	    add(dataAA);
	    add(dataIA);
	    
	    add(calculate);
	    add(cleanIndic);
	    
	    ButtonCleanIndic actionCleanIA = new ButtonCleanIndic(dataPA, dataRAP, dataAA, dataIA);
	    cleanIndic.addActionListener(actionCleanIA);
	    
	    ButtonCalculate actionCalculate = new ButtonCalculate(name, dataPA, dataRAP, dataAA, dataIA);
	    calculate.addActionListener(actionCalculate);
	    
	    /* Menu items */
	    new Exit(exit);								// Class to close the window
	    new Information(information);				// Class to display the window with the information of "PrioriJava"
	    new Instruction(instruction);				// Class to display the window with the instruction for users
	    new ChargeData(users, name, textArea);		// Class to charge data of the users
	    
		setLayout(null);
	}
	
	private JLabel subArea;
	private JTextArea textArea;
	private JScrollPane scrollArea;
	
	private JLabel name, user; 
	private JButton newUser, removeUser; 
	
	private JButton enter, cleanSubject; 
	private JLabel subjects, semesterOne, year, matter, initials, credits, average;
	public JTextField dataSem, dataYear, dataMatter, dataInit, dataCredits, dataAver;
	
	private JLabel FAE;
	private JButton enterFAE;
	private JTextField dataFAE;
	
	private JButton calculate, cleanIndic;
	private JLabel indicator, PA, RAP, AA, IA;
	private JTextField dataPA, dataRAP, dataAA, dataIA;
	
	public static final int DEFAULT_WIDTH = 860;
	public static final int DEFAULT_HEIGHT = 600;
	private static final long serialVersionUID = 1L;	// Avoid warnings of serialization runtime
}
